/***************************************************
* C source with CCS
*  File Name: MK316_accl_sensor.c
*  Description: check potentiometer and ACCL sensor out
*  , and turn on yellow LED and relay
*  COPYRIGHT 2016 MYCOMKITS.COM, owned by CNET LIMITED
*  $BEv%W%m%0%i%`$NCx:n8"$O!"@=:n<T!V%^%$%3%s%-%C%H%I%C%H%3%`1?1D!!M-8B2q<R%/%M%C%H!W$K5"B0$7$^$9!#(B
*  $BCx:n8"$rJ|4~$7$F$$$^$;$s$,!"Ev%W%m%0%i%`$r;H$C$?3X=,$NCf$G%W%m%0%i%`$r<+M3$KJQ99$7$F$*;H$$$/$@$5$$!#(B
***************************************************/
// include header file
#include	<12f1572.h>
#DEVICE ADC=8
// settings
// settings
#fuses	INTRC_IO, NOWDT, NOMCLR, NOBROWNOUT, PUT, NOLVP, NOPROTECT, NODEBUG
#fuses	NOCLKOUT, NOWRT, PLL_SW, NOSTVREN
#use delay(CLOCK = 4000000)
//
long value_setting=256;
long value_sensor=256;
//float value_sensorx=256;
//float value_sensory=256;
signed int value_x=0;
signed int value_y=0;
signed int Xoffset=0;   //x offset,  -127 to +127
signed int Yoffset=0;   //y offset,  -127 to +127
long value_sx[16];
long value_sy[16];
int hyste = 0;
int start_delay =40;
//int i;
// prototyping
#separate
void get_sensor();
#separate
void get_setting();
#separate
void initializing();
#separate
void check_adc();
// main
void main()
{
	//
	initializing();	//ADC port initialize
	output_low(PIN_A4);	//active high, Relay off
	output_high(PIN_A5);	//active low, LED off
	//calibration
	delay_ms(2000);
	//
	check_adc();
	//
    Xoffset = value_x;	//
    Yoffset = value_y;	//
    //
    output_low(PIN_A5);	// LED on
    delay_ms(100);
    output_high(PIN_A5);	// LED off
    delay_ms(100);
    output_low(PIN_A5);	// LED on
    delay_ms(100);
    output_high(PIN_A5);	// LED off
	// main loop
	while(1)
	{
		if(input(PIN_A3)==1)
		{
			delay_ms(50);	//check it again for chattaling
			if(input(PIN_A3)==1)
			{
				//
				get_setting();
				get_sensor();
				//
                if(start_delay > 0) start_delay = start_delay - 1;
                else
                {
                    start_delay = 0;
                    if(value_sensor > value_setting*0.9)
                    {
                        output_low(PIN_A5);	// LED on
                    }
                    else
                    {
                        output_high(PIN_A5);	// LED off
                    }
                    if(value_sensor > value_setting)
                    {

                        if(hyste == 0)
                        {
                            output_high(PIN_A4);	// Relay on
                            hyste = 50;
                        }
                    }
                    else if(hyste == 0)
                    {
                        output_low(PIN_A4);	// Relay off
                        hyste = 50;
                    }
                }
			}
		}
	}
}
//
#separate
void get_setting()
{
	set_adc_channel(0);	//must wait 65u
	delay_us(65);
	value_setting = read_adc();	// 0 to 256, 0.0V to 3.3V
	value_setting = 20 * value_setting;	// 0 to 10000
}
//
#separate
void get_sensor()
{
	// moving average for X axis and Y or Z
	// A1 shows X axis, A2 shows Z or Y axis
	// moving average
	int i;
        float value_sensorx=256;
        float value_sensory=256;
	for (i=15; i>0; i--)
	{
		value_sx[i] = value_sx[i-1];
		value_sy[i] = value_sy[i-1];
	}
	//
	check_adc();
	//
	value_x = value_x - Xoffset;
	value_y = value_y - Yoffset;
	value_sensorx = value_x;
	value_sensory = value_y;
	//
	value_sx[0] = value_sensorx * value_sensorx;	// 0 to 8100
	value_sy[0] = value_sensory * value_sensory;	// 0 to 8100
	// summing
	value_sensorx = 0;
	value_sensory = 0;
	for (i=0; i<16; i++)
	{
		value_sensorx = value_sensorx + value_sx[i];	// 0 to 129600
		value_sensory = value_sensory + value_sy[i];	// 0 to 129600
	}
	value_sensorx = value_sensorx / 16;	// 0 to 8100
	value_sensory = value_sensory / 16;	// 0 to 8100
	value_sensor = value_sensorx  + value_sensory;	// 0 to 16200
}
// system intializing
#separate
void initializing()
{
	SET_TRIS_A(0x0F);	//A0 to 3 are input, 4, 5 are output
	// A/D converter initialize AN1 and AN2
	setup_adc_ports(sAN0 | sAN1 | sAN2 | VSS_VDD);	// gnd to 5v
	setup_adc(ADC_CLOCK_DIV_8);			// 2usec
	// timer 1 intialize for hysteresis count down
	setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);
	set_timer1(0xF4F0);              // timer 1 setting almost 5msec
	enable_interrupts(INT_TIMER1);   // timer 1 enable
	enable_interrupts(GLOBAL);       // global enable
}
// timer 1 inturruption hysteresis count down
#int_timer1
void isr1(void)
{
	set_timer1(0xF4F0);             // timer 1 almost 5msec
	if(hyste > 1) hyste = hyste - 1;
	else hyste = 0;
}
//
#separate
void check_adc()
{
	set_adc_channel(1);	//must wait 65u
	delay_us(65);
	value_x = read_adc();		// convert it into floating, 0 to 255
	value_x = value_x - 127;	//-90 to 90, 0.4V to 2.8V
	set_adc_channel(2);	//must wait 65u
	delay_us(65);
	value_y = read_adc();	// convert it into floating, 0 to 256
	value_y = value_y - 127;	//-90 to 90, 0.4V to 2.8V
}
